package ddoscoo

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// CreateDomainResource invokes the ddoscoo.CreateDomainResource API synchronously
func (client *Client) CreateDomainResource(request *CreateDomainResourceRequest) (response *CreateDomainResourceResponse, err error) {
	response = CreateCreateDomainResourceResponse()
	err = client.DoAction(request, response)
	return
}

// CreateDomainResourceWithChan invokes the ddoscoo.CreateDomainResource API asynchronously
func (client *Client) CreateDomainResourceWithChan(request *CreateDomainResourceRequest) (<-chan *CreateDomainResourceResponse, <-chan error) {
	responseChan := make(chan *CreateDomainResourceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.CreateDomainResource(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// CreateDomainResourceWithCallback invokes the ddoscoo.CreateDomainResource API asynchronously
func (client *Client) CreateDomainResourceWithCallback(request *CreateDomainResourceRequest, callback func(response *CreateDomainResourceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *CreateDomainResourceResponse
		var err error
		defer close(result)
		response, err = client.CreateDomainResource(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// CreateDomainResourceRequest is the request struct for api CreateDomainResource
type CreateDomainResourceRequest struct {
	*requests.RpcRequest
	HttpsExt    string                            `position:"Query" name:"HttpsExt"`
	SourceIp    string                            `position:"Query" name:"SourceIp"`
	RsType      requests.Integer                  `position:"Query" name:"RsType"`
	RealServers *[]string                         `position:"Query" name:"RealServers"  type:"Repeated"`
	InstanceIds *[]string                         `position:"Query" name:"InstanceIds"  type:"Repeated"`
	ProxyTypes  *[]CreateDomainResourceProxyTypes `position:"Query" name:"ProxyTypes"  type:"Repeated"`
	Domain      string                            `position:"Query" name:"Domain"`
}

// CreateDomainResourceProxyTypes is a repeated param struct in CreateDomainResourceRequest
type CreateDomainResourceProxyTypes struct {
	ProxyPorts *[]string `name:"ProxyPorts" type:"Repeated"`
	ProxyType  string    `name:"ProxyType"`
}

// CreateDomainResourceResponse is the response struct for api CreateDomainResource
type CreateDomainResourceResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateCreateDomainResourceRequest creates a request to invoke CreateDomainResource API
func CreateCreateDomainResourceRequest() (request *CreateDomainResourceRequest) {
	request = &CreateDomainResourceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ddoscoo", "2020-01-01", "CreateDomainResource", "", "")
	request.Method = requests.POST
	return
}

// CreateCreateDomainResourceResponse creates a response to parse from CreateDomainResource response
func CreateCreateDomainResourceResponse() (response *CreateDomainResourceResponse) {
	response = &CreateDomainResourceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
